#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <unistd.h>
#include <iostream>
#include <vector>
#include<queue>
using namespace std;

#include "common.h"
#include "marshal.h"
#include "update.h"

#define vit vector<int>::iterator;
#define vit2 vector<vector<int>>::iterator
#define INF 9876543


int ja;   // ktory hrac som
Mapa mapa;
Stav stav;
Tah mojTah;


// skratka. pouzivajte v zistiTah().
#define vykonaj(p) vykonajPrikaz(mapa, stav, mojTah, (p))
struct coord{

int x;
int y;
};

struct mesto{
int x;
int y;
vector<vector<int>> pole;
};



struct hrdina{
int id;
int tox;
int toy;
int cesta;
vector<mesto>::iterator town;
vector<vector<int>>trasa;
};


map<int,hrdina> Hrdinovia;
vector<mesto> Mesta;



void BFS(vector<vector<int>> & tpole,int x,int y)
{

tpole[x][y]=47;
queue<int> Q;

Q.push(x);
Q.push(y);
Q.push(48);

while(Q.size()>0){

int tx=Q.front();
Q.pop();
int ty=Q.front();
Q.pop();
int tk=Q.front();
Q.pop();


for(int i=max(0,tx-1); i<=min(mapa.h-1,tx+1); i++)
for(int j=max(0,ty-1); j<=min(mapa.w-1,ty+1); j++)
if(tpole[i][j]==INF){
//cerr<<"pridavam policko"<<i<<" "<<j<<endl;
 tpole[i][j]=tk; Q.push(i); Q.push(j); Q.push(tk+1);}





}




}




void BFS_mesto(vector<coord>::iterator it ){

vector<vector<int>> temp_pole;
temp_pole=mapa.pole;
for(int i=0; i<mapa.h; i++)
	for(int j=0; j<mapa.w; j++)
		if(temp_pole[i][j]>0)
			temp_pole[i][j]=INF;


BFS(temp_pole,it->x,it->y);

Mesta.push_back({it->x,it->y,temp_pole});



}










// main() zavola tuto funkciu, ked nacita mapu
void inicializuj() {
vector<coord> mesta;  
cerr<<"super zacal som"<<endl;
for(int i=0; i<mapa.h; i++)
	for(int j=0; j<mapa.w; j++)
		if(mapa.pole[i][j]==MAPA_MESTO)
			mesta.push_back({i,j});

cerr<<"nasiel som "<<mesta.size()<<" miest"<<endl;
for (auto it=mesta.begin(); it!=mesta.end();it++)
		BFS_mesto(it);

cerr<<"Lol az sem som sa dostal"<<endl;
for(auto it=Mesta.begin(); it!=Mesta.end(); it++)
{
/*
for(int i=0; i<mapa.h; i++){
for(int j=0; j<mapa.w; j++)

//cerr<<it->pole[i][j]<<" ";
fprintf(stderr,"%d ",it->pole[i][j]);
cerr<<"/n";
}
*/

cerr<<"mam tu mesto"<<it->x<<" "<<it->y<<endl;
}

}



void ZadajCestu(map<int,hrdina>::iterator hrdina){

for(auto it=stav.questy.begin();it!= stav.questy.end(); it++)
{

int best=INF;
auto itNajpredmet=stav.predmety.begin();
auto aktMesto=Mesta.begin();

//najdeme mesto kam chceme int
for(auto itt=Mesta.begin(); itt!=Mesta.end(); itt++)
if(itt->x==it->cielX && itt->y==it->cielY){
aktMesto=itt; break;
}

//prejdeme vsetky predmety a hladame taky ktory chceme

for(auto it1=stav.predmety.begin(); it1!=stav.predmety.end(); it1++)
{

	
bool konci=false;
	if(it1->typ==it->ziadanyPredmet){
	for(auto q=Hrdinovia.begin(); q!=Hrdinovia.end(); q++)
	if(q->second.toy==it1->y && q->second.tox==it1->x){ cerr<<"po tento predmet uz niekto ide!!!"<<endl;konci=true;}
	if(konci==true) continue;
	cerr<<"Ziadany predmet pre hrdinu "<<hrdina->first<<" najdeny so suradnicami "<<it1->x<<" "<<it1->y<<endl;
		if(aktMesto->pole[it1->y][it1->x]<best){ best=aktMesto->pole[it1->y][it1->x]; itNajpredmet=it1; }


	}

	if(best!=INF)
	{
	vector<vector<int>>V=mapa.pole;
	cerr<<"initialization complete!!!"<<endl;
	for(int i=0; i<mapa.h; i++)
	for(int j=0; j<mapa.w; j++)
	if(V[i][j]>0)V[i][j]=INF;

	BFS(V,itNajpredmet->y,itNajpredmet->x);
	/*
	for(int i=0; i<mapa.h; i++){
	for(int j=0; j<mapa.w; j++)
	cerr<<V[i][j]<<" ";
	cerr<<"\n";
	}
	*/

	hrdina->second.trasa=V;
	hrdina->second.cesta=true;
	hrdina->second.town=aktMesto;
	hrdina->second.tox=itNajpredmet->x;
	hrdina->second.toy=itNajpredmet->y;
	cerr<<"Najblizsi predmet je na suradniciach "<<itNajpredmet->x<<" "<<itNajpredmet->y<<endl; }
	else cerr<<"nepodarilo sa najst quest"<<endl;
}
}
}


int sgn(int c) {
  if (c < 0) return -1;
  if (c > 0) return 1;
  return 0;
}


// main() zavola tuto funkciu, ked chce vediet, ake prikazy chceme vykonat
void zistiTah() {
  // (sem patri vas kod)
  // priklad: if (vykonaj(Prikaz::chod(niekto, x, y))) { /* podarilo sa */ }

  // mam malo hrdinov? hura verbovat!
  int mojiHrdinovia = 0;
  FOREACH (it, stav.zivocichy) {
    if (it->ktorehoHraca == ja) mojiHrdinovia++;
  }
  if (mojiHrdinovia < 1) {
    for (int y = 0; y < mapa.h; y++) {
      for (int x = 0; x < mapa.w; x++) {
        if (mapa.zisti(x, y) == MAPA_MESTO) {
          vykonaj(Prikaz::verbuj(rand() % HRDINA_POCET_TYPOV, x, y));
        }
      }
    }
  }

  // ked uz mam hrdinov, tak nimi pohnem

cerr<<"mam "<<mojiHrdinovia<<" hrdinov!!!"<<endl;
for(auto it=Hrdinovia.begin(); it!=Hrdinovia.end(); it++)
cerr<<"ID "<<it->second.id<<" targetx "<<it->second.tox<<" targety "<<it->second.toy<<endl;
cerr<<"pocet pracovnych ponuk je:"<<stav.pracovnePonuky.size()<<endl;


for(auto it=stav.zivocichy.begin(); it!=stav.zivocichy.end(); it++)

		if(it->ktorehoHraca==ja){

			
			if(Hrdinovia.find(it->id)!=Hrdinovia.end()){
				if(Hrdinovia[it->id].cesta==false)
					ZadajCestu(Hrdinovia.find(it->id));
			
				//else cerr<<"Cesta je true"<<endl;
			}

			else{ vector<vector<int>> Null;Hrdinovia[it->id]={it->id,0,0,false,Mesta.begin(),Null}; cerr<<"Pridavam hrdinu"<<endl;};
}





for(auto it=Hrdinovia.begin(); it!=Hrdinovia.end(); it++){

if(it->second.cesta>0){



cerr<<"chcem sa presuvat"<<endl;
auto  id=stav.zivocichy.begin();
for(auto itt=stav.zivocichy.begin(); itt!=stav.zivocichy.end(); itt++)
if(itt->id==it->first){ id=itt; cerr<<"nasiel som id hrdinu"<<endl; }

if(it->second.trasa[id->y][id->x]==47) it->second.cesta=22;

if(id->povodX == id->x && id->povodY==id->y)
{
int xn=id->x+rand()%3-1;
int yn=id->y+rand()%3-1;
vykonaj(Prikaz::chod(id->id,yn,xn));

}
/*
for(int i=0; i<mapa.h; i++){
for(int j=0; j<mapa.w; j++)
cerr<<it->second.trasa[i][j]<<" ";
cerr<<"\n";
}

*/
cerr<<id->nesenyPredmet<<endl;
if(it->second.cesta==1){

cerr<<it->second.trasa[id->y][id->x]<<endl;
for(int i=max(id->y-1,0); i<=min(id->y+1,mapa.h-1); i++)
for(int j=max(id->x-1,0); j<=min(id->x+1,mapa.w-1); j++)
if(it->second.trasa[i][j]==it->second.trasa[id->y][id->x]-1){
cerr<<"Presuvam sa z "<<id->x<< " a "<<id->y<<" na "<<i<<" a "<<j<<" z "<<it->second.trasa[i][j]<<" "<<it->second.trasa[id->y][id->x]<<endl;
vykonaj(Prikaz::chod(id->id, j, i));

if(vykonaj(Prikaz::chod(id->id,j,i))) cerr<<"uspesne presunuty"<<endl;;
break; break;

}
}
else{


for(int i=max(id->y-1,0); i<=min(id->y+1,mapa.h-1); i++)
for(int j=max(id->x-1,0); j<=min(id->x+1,mapa.w-1); j++)
if(it->second.town->pole[i][j]==it->second.town->pole[id->y][id->x]-1){
if(it->second.town->pole[i][j]==47){
if(vykonaj(Prikaz::poloz(id->id, j, i)))cerr<<"Polozil som"<<endl;
it->second.cesta=false; }
else
vykonaj(Prikaz::chod(id->id, j, i));
}
//cerr<<"Presuvam sa z "<<id->x<< " a "<<id->y<<" na "<<i<<" a "<<j<<" z "<<it->second.trasa[i][j]<<" "<<it->second.trasa[id->y][id->x]<<endl;
/*
if(mapa.pole[i][j]==MAPA_MESTO){
if(vykonaj(Prikaz::poloz(id->id, j, i)))cerr<<"Polozil som"<<endl;}
else if(vykonaj(Prikaz::chod(id->id,j,i))) cerr<<"uspesne presunuty"<<endl;;
*/
break; break;
}











}


}


/*
  bool poholSomSa;
 

 do {
    poholSomSa = false;

    // skusim kazdemu dat jeden prikaz
    FOREACH (it, stav.zivocichy) {
      if (it->ktorehoHraca != ja) continue;

      // najdem najblizsiu potvoru
      int bestx = -1, besty = -1, bestd = mapa.w * mapa.h;
      FOREACH (itp, stav.zivocichy) {
        if (itp->ktorehoHraca != -1) continue;
        int d = vzdialenost(it->x, it->y, itp->x, itp->y);
        if (d < bestd) {
          bestx = itp->x;
          besty = itp->y;
          bestd = d;
        }
      }

	cerr<<"Nasiel som najblizsiu potoru"<<bestx<<" "<<besty<<endl;

      if (bestx == -1) {
        // ak tam nie je ziadna potvora, nahodne sa pohnem
        int nx = it->x + rand() % 3 - 1;
        int ny = it->y + rand() % 3 - 1;
        if (vykonaj(Prikaz::chod(it->id, nx, ny))) poholSomSa = true;
      }
      else if (bestd == 1) {
        // ak je hned pri mne, zautocim
        if (vykonaj(Prikaz::utoc(it->id, bestx, besty))) poholSomSa = true;
	cerr<<"Zautocil som"<<endl;     
 }
      else {
        // ak je dalej, vydam sa tym smerom
        int nx = it->x + sgn(bestx - it->x);
        int ny = it->y + sgn(besty - it->y);
        if (vykonaj(Prikaz::chod(it->id, nx, ny))) poholSomSa = true;
      }
    }

    // mozno mi este zostali AP - zase skusim kazdym pohnut...
    // (ak uz sa nikto pohnut nedokazal, nejdem to dalej skusat)
  } while (poholSomSa);


*/



  if (mojTah.ap) {
    // napriklad takto sa vypisuju debugovacie spravy
    fprintf(stderr, "este mi zostalo %d Action Points\n", mojTah.ap);
  }
}


int main() {
  // v tejto funkcii su vseobecne veci, nemusite ju menit (ale mozte).

  unsigned int seed = time(NULL) * getpid();
  srand(seed);

  nacitaj(cin, ja);
  nacitaj(cin, mapa);
  fprintf(stderr, "START ja=%d, pid=%d, seed=%u\n", ja, getpid(), seed);
  inicializuj();

  while (cin.good()) {
    nacitaj(cin, stav);
    mojTah = zaciatokTahu(stav, ja);
    zistiTah();
    uloz(cout, mojTah.prikazy);
    cout << ".\n" << flush;   // bodka a flush = koniec odpovede
  }

  return 0;
}

