#include "marshal.h"
#include "common.h"
#include "SDL.h"
#include "SDL_ttf.h"
#include "SDL_image.h"
#include "observer.h"
#include <set>

void renderAdditionalInfo(SDL_Surface* surface, SDL_Rect rect) {
  char buffer[100];
  
  sprintf(buffer, "Ťah %d", game_time / GAMETIME_UNITS);    
  SDL_Surface* text = TTF_RenderUTF8_Blended(bigfont, buffer, COLOR_ORANGE);
  SDL_BlitSurface(text, NULL, surface, &rect);
  free(text);
  
  rect.y += 20;
      
  int leading_gold = -1;
  for (int i = 0; i < NUM_PLAYERS; i++) {
    if (leading_gold < states[game_time / GAMETIME_UNITS].hraci[i].zlato)
      leading_gold = states[game_time / GAMETIME_UNITS].hraci[i].zlato;
  }
  
  int second_gold = -1;
  for (int i = 0; i < NUM_PLAYERS; i++) {
    if (second_gold < states[game_time / GAMETIME_UNITS].hraci[i].zlato)
      if (leading_gold != states[game_time / GAMETIME_UNITS].hraci[i].zlato)
        second_gold = states[game_time / GAMETIME_UNITS].hraci[i].zlato;
  }
  
  int third_gold = -1;
  for (int i = 0; i < NUM_PLAYERS; i++) {
    if (third_gold < states[game_time / GAMETIME_UNITS].hraci[i].zlato)
      if (leading_gold != states[game_time / GAMETIME_UNITS].hraci[i].zlato)
        if (second_gold != states[game_time / GAMETIME_UNITS].hraci[i].zlato)
          third_gold = states[game_time / GAMETIME_UNITS].hraci[i].zlato;
  }
  
  int fourth_gold = -1;
  for (int i = 0; i < NUM_PLAYERS; i++) {
    if (fourth_gold < states[game_time / GAMETIME_UNITS].hraci[i].zlato)
      if (leading_gold != states[game_time / GAMETIME_UNITS].hraci[i].zlato)
        if (second_gold != states[game_time / GAMETIME_UNITS].hraci[i].zlato)
          if (third_gold != states[game_time / GAMETIME_UNITS].hraci[i].zlato)          
            fourth_gold = states[game_time / GAMETIME_UNITS].hraci[i].zlato;
  }
  
  int fifth_gold = -1;
  for (int i = 0; i < NUM_PLAYERS; i++) {
    if (fifth_gold < states[game_time / GAMETIME_UNITS].hraci[i].zlato)
      if (leading_gold != states[game_time / GAMETIME_UNITS].hraci[i].zlato)
        if (second_gold != states[game_time / GAMETIME_UNITS].hraci[i].zlato)
          if (third_gold != states[game_time / GAMETIME_UNITS].hraci[i].zlato)          
            if (fourth_gold != states[game_time / GAMETIME_UNITS].hraci[i].zlato)                      
              fifth_gold = states[game_time / GAMETIME_UNITS].hraci[i].zlato;
  }
  
  if (fifth_gold < 0)
    fifth_gold = 0;
    
  for (int i = 0; i < NUM_PLAYERS; i++) {
    rect.y += 40;
    
    strcpy(buffer, PLAYER_NAMES[i]);
    text = TTF_RenderUTF8_Blended(bigfont, buffer, PLAYER_COLORS[i]);
    SDL_BlitSurface(text, NULL, surface, &rect);
    free(text);
    
    rect.x += 250;

    SDL_BlitSurface(money_icon, NULL, surface, &rect);
    
    rect.x += 50;

    sprintf(buffer, "%d", states[game_time / GAMETIME_UNITS].hraci[REVERSE_PLAYER_ORDER[i]].zlato);
    text = TTF_RenderText_Blended(bigfont, buffer, COLOR_ORANGE);
    SDL_BlitSurface(text, NULL, surface, &rect);
    free(text);
    
    rect.x += 100;

    
    
    if (fifth_gold == states[game_time / GAMETIME_UNITS].hraci[REVERSE_PLAYER_ORDER[i]].zlato)
      SDL_BlitSurface(medal_icon_5, NULL, surface, &rect);
    else {
      if (leading_gold == states[game_time / GAMETIME_UNITS].hraci[REVERSE_PLAYER_ORDER[i]].zlato)
        SDL_BlitSurface(medal_icon, NULL, surface, &rect);
      if (second_gold == states[game_time / GAMETIME_UNITS].hraci[REVERSE_PLAYER_ORDER[i]].zlato)
        SDL_BlitSurface(medal_icon_2, NULL, surface, &rect);
      if (third_gold == states[game_time / GAMETIME_UNITS].hraci[REVERSE_PLAYER_ORDER[i]].zlato)
        SDL_BlitSurface(medal_icon_3, NULL, surface, &rect);
      if (fourth_gold == states[game_time / GAMETIME_UNITS].hraci[REVERSE_PLAYER_ORDER[i]].zlato)
        SDL_BlitSurface(medal_icon_4, NULL, surface, &rect);
    }
    
    rect.x -= 400;
  }
}
