#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <unistd.h>
#include <iostream>
#include <vector>
#include<queue>
#include<algorithm>
using namespace std;

#include "common.h"
#include "marshal.h"
#include "update.h"

#define vit vector<int>::iterator;
#define vit2 vector<vector<int>>::iterator
#define INF 9876543


int ja;   // ktory hrac som
Mapa mapa;
Stav stav;
Tah mojTah;


// skratka. pouzivajte v zistiTah().
#define vykonaj(p) vykonajPrikaz(mapa, stav, mojTah, (p))


struct mesto{
int x;
int y;
};



struct hrdina{
int id;
int xpredmet;
int ypredmet;
int zviera;
int typ;
int xm;
int ym;
};


vector<hrdina> Hrdinovia;
vector<mesto> Mesta;


vector<vector<vector<vector<int>>>>mBFS;


void BFS(vector<vector<int>> & tpole,int x,int y)
{

tpole[x][y]=47;
queue<int> Q;

Q.push(x);
Q.push(y);
Q.push(48);

while(Q.size()>0){

int tx=Q.front();
Q.pop();
int ty=Q.front();
Q.pop();
int tk=Q.front();
Q.pop();


for(int i=max(0,tx-1); i<=min(mapa.h-1,tx+1); i++)
for(int j=max(0,ty-1); j<=min(mapa.w-1,ty+1); j++)
if(tpole[i][j]==INF){
//cerr<<"pridavam policko"<<i<<" "<<j<<endl;
 tpole[i][j]=tk; Q.push(i); Q.push(j); Q.push(tk+1);}





}




}


vector<Zivocich>::iterator zistiIDHrdinu(int id){

vector<Zivocich>::iterator t=stav.zivocichy.end();
for(auto it=stav.zivocichy.begin(); it!=stav.zivocichy.end(); it++)
if(it->id==id) return it;

return t;
}

vector<Predmet>::iterator zistiItem(int x,int y){
vector<Predmet>::iterator t=stav.predmety.end();

for(auto item=stav.predmety.begin(); item!=stav.predmety.end(); item++)
if(item->x==x && item->y==y) return item;

return t;
}


vector<Zivocich>::iterator zistiIDHrdinuXY(int x,int y){

for(auto it=stav.zivocichy.begin(); it!=stav.zivocichy.end(); it++)
if(it->x==x && it->y==y) return it;


return stav.zivocichy.end();
}

// main() zavola tuto funkciu, ked nacita mapu
void inicializuj() {
//najdenie miest
cerr<<"super zacal som"<<endl;
for(int i=0; i<mapa.h; i++)
	for(int j=0; j<mapa.w; j++)
		if(mapa.pole[i][j]==MAPA_MESTO)
			Mesta.push_back({i,j});

cerr<<"nasiel som "<<Mesta.size()<<" miest"<<endl;

/*
//BFS
mBFS.resize(mapa.h,vector<vector<vector<int>>>(mapa.h,vector<vector<int>>(mapa.h,vector<int>(mapa.w))));
//ciste pole
vector<vector<int>>ciste=mapa.pole;
//vycistime ho
for(int i=0; i<mapa.h; i++)
for(int j=0; j<mapa.w; j++)
if(ciste[i][j]>0) ciste[i][j]=INF; 

//pre kazde policko is spravime bfs
for(int i=0; i<mapa.h; i++)
for(int j=0; j<mapa.w; j++){

vector<vector<int>>V=ciste;

BFS(V,i,j);
mBFS[i][j]=V;

}
*/
}

vector<vector<int>> zistiBFS(int x,int y){
vector<vector<int>>V=mapa.pole;
//vycistime ho
//cerr<<"zacinam zisti"<<endl;
for(int i=0; i<mapa.h; i++)
for(int j=0; j<mapa.w; j++)
if(V[i][j]>0) V[i][j]=INF; 

//cerr<<"predBFS"<<endl;
BFS(V,x,y);
//cerr<<"pred returnom"<<endl;
return V;
}


bool compare(Quest a,Quest b)
{return a.zlato>b.zlato;}

void vypismapu(vector<vector<int>>& V){

for(int i=0; i<mapa.h; i++){
for(int j=0; j<mapa.w; j++)
cerr<<V[i][j]<<" ";
cerr<<"\n";
}

}

void ZadajCestu(vector<hrdina>::iterator h){

//suradnice hrdinu
auto H=zistiIDHrdinu(h->id);
int x=H->x;
int y=H->y;

auto quest=stav.questy.begin();
int najzviera=-1;
int xnajpredmet=-1;
int ynajpredmet=-1;
int cena=0;
int maxcena=INF;
int vzdialenost=INF;
int typ=0;
cerr<<"zadavam cestu"<<endl;
//najdeme najdrahsi quest

vector<Quest>q=stav.questy;
sort(q.begin(),q.end(),compare);
/*
for(auto it=stav.questy.begin();it!= stav.questy.end(); it++)
{
if(it->zlato>cena && it->zlato<maxcena){ cena=it->zlato; quest=it;}
}
*/
for(auto it1=q.begin(); it1!=q.end(); it1++){
quest=it1;
cena=it1->zlato;
vzdialenost=INF;
//najdeme najvhodnejsi predmet
for(auto it=stav.predmety.begin(); it!=stav.predmety.end(); it++){
//cerr<<"zadavam BFS"<<endl;
vector<vector<int>> V=zistiBFS(y,x);
//vypismapu(V);
//cerr<<"BFS najdene"<<endl;
if(V[it->y][it->x]<vzdialenost && it->typ==it1->ziadanyPredmet){ vzdialenost=V[it->y][it->x]; xnajpredmet=it->x; ynajpredmet=it->y;typ=1;}
}

cerr<<"zviera najdene"<<endl;
//najdeme najvodnejsie zviera
if(stav.zivocichy.size()>0)
for(auto it=stav.zivocichy.begin(); it!=stav.zivocichy.end(); it++){
//cerr<<"zadavam BFS"<<endl;
vector<vector<int>> V=zistiBFS(y,x);
//cerr<<"BFS zadane"<<endl;
if(V[it->y][it->x]<vzdialenost && it->nesenyPredmet==it1->ziadanyPredmet){ vzdialenost=V[it->y][it->x]; najzviera=it->id; typ=2;}
}

//cerr<<"zadavanie takmer ukoncene"<<endl;
if(typ==1)
	{h->xpredmet=xnajpredmet; h->ypredmet=ynajpredmet; h->xm=quest->cielX; h->ym=quest->cielY;h->typ=typ; break;}
else if(typ==2)
	{h->typ=2; h->zviera=najzviera; h->xm=quest->cielX; h->ym=quest->cielY;break;}

}
//cerr<<"zadavanie ukoncene"<<endl;
}

int sgn(int c) {
  if (c < 0) return -1;
  if (c > 0) return 1;
  return 0;
}

void zistiTah(){

//zistim pocet hrdinov
int pocetHrdinov=0;
for(auto it=stav.zivocichy.begin(); it!=stav.zivocichy.end(); it++)
if(it->ktorehoHraca==ja)
pocetHrdinov++;
//ak ich je malo
cerr<<"Pocet hrdinov je "<<pocetHrdinov<<"\n";
if(pocetHrdinov+stav.pracovnePonuky.size()<2){
mesto M=Mesta[rand()%Mesta.size()];
if(vykonaj(Prikaz::verbuj(2, M.y, M.x)))
cerr<<"Prikaz na pridanie hrdinu uspesne odoslany"<<endl;
}


for(auto it=stav.zivocichy.begin(); it!=stav.zivocichy.end(); it++)
	if(it->ktorehoHraca==ja){
		bool ok=false;
		for(auto h=Hrdinovia.begin(); h!=Hrdinovia.end(); h++)
			if(h->id==it->id)
				ok=true;	//ak sa nasiel hrdina

		if(ok==false) Hrdinovia.push_back({it->id,0,0,0,0,0,0});
		}

cerr<<"inicializovani vsetci zivocichovia"<<endl;
//pridany vsetci novy hrdinovia
//tu vymazem vsetkych mrtvych

vector<vector<hrdina>::iterator> zmazat;

for(auto h=Hrdinovia.begin(); h!=Hrdinovia.end(); h++)
	if(zistiIDHrdinu(h->id)==stav.zivocichy.end()){
		zmazat.push_back(h);}

for(auto it=zmazat.begin(); it!=zmazat.end(); it++){
//cerr<<"Hrdina zmazat"<<it->id<<endl;
Hrdinovia.erase(*it);}


cerr<<"zmazani vsetci zivociachovia"<<endl;
//podme skontrolovat aktualnost objektov ktore maju v praci

for(auto h=Hrdinovia.begin(); h!=Hrdinovia.end(); h++)
	if(h->typ==1){

		if(zistiItem(h->xpredmet,h->ypredmet)==stav.predmety.end()){ h->typ=0; cerr<<"mazem"<<endl;}

		}
	else if(h->typ==2)
		if(zistiIDHrdinu(h->id)==stav.zivocichy.end()){ h->typ=0;cerr<<"mazem2"<<endl;}
cerr<<"Aktualnosti skontrolovane"<<endl;
//aktualnost prac skontrolovana
//podmo konecne rozdat prace


for(auto h=Hrdinovia.begin(); h!=Hrdinovia.end(); h++)
        if(h->typ==1){
if(zistiIDHrdinu(h->zviera)==stav.zivocichy.end()) h->typ=0;



}


for(auto h=Hrdinovia.begin(); h!=Hrdinovia.end(); h++)
{

if(h->typ==0)		//nema pracu
{
ZadajCestu(h);
cerr<<"cesta zadana"<<endl;}
else if(h->typ==-1) h->typ=0;
}

//prace rozdelene


//podme sa hybat
//cerr<<"kontrola"<<endl;

for(int w=1; w<=10; w++)
for(auto h=Hrdinovia.begin(); h!=Hrdinovia.end(); h++){
auto H=zistiIDHrdinu(h->id);
bool posunute=false;
if(h->typ==1){	//ak mam ciel item
cerr<<"zacinam cast 1"<<endl;
vector<vector<int>> pole=zistiBFS(h->ypredmet,h->xpredmet);
cerr<<"Chcem sa dostat na suradnice "<<H->x<<" "<<H->y<<endl;

for(int i=max(H->y-1,0); i<=min(H->y+1,mapa.h-1); i++)
for(int j=max(H->x-1,0); j<=min(H->x+1,mapa.w-1); j++)
if(pole[H->y][H->x]==pole[i][j]+1){ 		//sem sa chcem pohnut;
//skontrolujme ci na tomto policku nieco nieje
auto ziv=zistiIDHrdinuXY(i,j);
if(ziv!=stav.zivocichy.end()) continue;		//ak je na policku zviera

if(vykonaj(Prikaz::chod(h->id,j,i))){ cerr<<"Posuvam sa"<<endl; posunute=true;}

if(pole[H->y][H->x]>48 && H->nesenyPredmet!=-1)
/*for(int i=max(H->y-1,0); i<=min(H->y+1,mapa.h-1); i++)
for(int j=max(H->x-1,0); j<=min(H->x+1,mapa.w-1); j++)*/
if(vykonaj(Prikaz::poloz(h->id, H->povodX, H->povodY))){;cerr<<"Zobral som nechtiac iny item - polozil som ho"<<endl;};

if(H->nesenyPredmet!=-1){cerr<<"mam premet"<<endl; h->typ=3; break;break;}

}
if(posunute==false)
for(int i=max(H->y-1,0); i<=min(H->y+1,mapa.h-1); i++)
for(int j=max(H->x-1,0); j<=min(H->x+1,mapa.w-1); j++)
if(pole[H->y][H->x]==pole[i][j] && (H->x!=j || H->y!=i)){             //sem sa chcem pohnut;
//skontrolujme ci na tomto policku nieco nieje


auto ziv=zistiIDHrdinuXY(i,j);
if(ziv!=stav.zivocichy.end()) continue;         //ak je na policku zviera

if(vykonaj(Prikaz::chod(h->id,j,i))){ cerr<<"Posuvam sa"<<endl; posunute=true;}
}

//cerr<<"koncim cast 1"<<endl;
}



else if(h->typ==2){			//ak mam ciel zviera
cerr<<"zacinam cast 2"<<endl;
auto potvora=zistiIDHrdinu(h->zviera);


if(potvora==stav.zivocichy.end()){cerr<<"zivocich neexituje"<<endl; h->typ=0; continue;}
else cerr<<"Chcem sa dostat na suradnice "<<potvora->x<<" "<<potvora->y<<endl;

//cerr<<"pred bfs"<<endl;
vector<vector<int>>pole=zistiBFS(potvora->y,potvora->x);
//cerr<<"po bfs"<<endl;
for(int i=max(H->y-1,0); i<=min(H->y+1,mapa.h-1); i++)
for(int j=max(H->x-1,0); j<=min(H->x+1,mapa.w-1); j++)
if(pole[H->y][H->x]==pole[i][j]+1){             //sem sa chcem pohnut;
//skontrolujme ci na tomto policku nieco nieje
//cerr<<"som v polke"<<endl;
if(h->typ==3)continue;
if(pole[i][j]==47)
if(vykonaj(Prikaz::utoc(h->id,j,i))) cerr<<"Zautocil som"<<endl;
if(H->nesenyPredmet!=-1){cerr<<"mam premet"<<endl; h->typ=3; break;break;}
auto item=zistiItem(i,j);
if(item!=stav.predmety.end()) continue;         //ak nieco na policku je
auto ziv=zistiIDHrdinuXY(i,j);
if(ziv!=stav.zivocichy.end()) continue;         //ak je na policku zviera

if(vykonaj(Prikaz::chod(h->id,j,i))){ cerr<<"Pohol som sa"<<endl;posunute=true;}
}
//cerr<<"koncim cast 2"<<endl;
}
else if(h->typ==3){		//ak mam predmet a nesiem ho domov
cerr<<"zacinam cast 3"<<h->xm<<" "<<h->ym<<endl;
if(H->nesenyPredmet==-1)h->typ=-1;
vector<vector<int>> pole=zistiBFS(h->ym,h->xm);
if(pole[H->y][H->x]==47)if(vykonaj(Prikaz::poloz(h->id,H->x+1,H->y+1))){ cerr<<"Nudyovo polozeny"<<endl; h->typ=0;}
cerr<<" velkost "<<pole[H->y][H->x]<<endl;
for(int i=max(H->y-1,0); i<=min(H->y+1,mapa.h-1); i++)
for(int j=max(H->x-1,0); j<=min(H->x+1,mapa.w-1); j++)
if(pole[H->y][H->x]==pole[i][j]+1){             //sem sa chcem pohnut;
if(h->typ!=3)continue;
if(pole[i][j]<=48){
	if(vykonaj(Prikaz::poloz(h->id, j, i))){;cerr<<"polozil som"<<endl;};
	if(H->nesenyPredmet==-1){ h->typ=0;break;}

}
else
 if(vykonaj(Prikaz::chod(h->id,j,i))){ cerr<<"Pohol som sa"<<endl; posunute=true;i+=10; j+=10;}

}
}

//cerr<<"koncim cast 3"<<endl;


if(posunute==false)
for(int i=max(H->y-1,0); i<=min(H->y+1,mapa.h-1); i++)
for(int j=max(H->x-1,0); j<=min(H->x+1,mapa.w-1); j++)
{
bool idem=rand()%2;

if(idem==true)
if(vykonaj(Prikaz::chod(h->id,j,i))){ cerr<<"Pohol som sa"<<endl; posunute=true;i+=10; j+=10;}


}


}
}
int main() {
  // v tejto funkcii su vseobecne veci, nemusite ju menit (ale mozte).

  unsigned int seed = time(NULL) * getpid();
  srand(seed);

  nacitaj(cin, ja);
  nacitaj(cin, mapa);
  fprintf(stderr, "START ja=%d, pid=%d, seed=%u\n", ja, getpid(), seed);
	cerr<<"Verzia 0.0.1 - Farmar"<<endl;
  inicializuj();

  while (cin.good()) {
cerr<<"cas je "<<stav.cas<<endl;    
nacitaj(cin, stav);
    mojTah = zaciatokTahu(stav, ja);
   zistiTah();
	cerr<<"este mi zostalo "<<mojTah.ap;
    uloz(cout, mojTah.prikazy);
    cout << ".\n" << flush;   // bodka a flush = koniec odpovede
  }

  return 0;
}

